package com.siit.wfw.frame.jmail;

import com.alibaba.fastjson.JSONObject;
import com.siit.wfw.frame.jmail.MailModel;
import com.siit.wfw.frame.jmail.MailTemplate;
import com.siit.wfw.frame.jmail.haier.SendMailHaier;
import com.siit.wfw.frame.utils.Convert;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import org.dom4j.Document;
import org.dom4j.DocumentHelper;
import org.dom4j.Element;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.core.io.ClassPathResource;
import org.springframework.stereotype.Component;

@Component
public class SiitMailTools {

   private final Logger logger = LoggerFactory.getLogger(SiitMailTools.class);
   private String company = "haier";


   public boolean sendMail(JSONObject param) throws Exception {
      return this.sendMail(param, "default");
   }

   public boolean sendMail(JSONObject param, String temp) throws Exception {
      String path = "siitmail/" + this.company + "/" + temp + ".html";
      MailModel model = this.loadTemp(path);
      if(model != null) {
         if("haier".equals(Convert.toReadStr(this.company))) {
            SendMailHaier tools = new SendMailHaier();
            return tools.sendMail(param, model);
         } else {
            this.logger.error("没有配置发邮件公司信息！[siit.mail.company]");
            return true;
         }
      } else {
         return true;
      }
   }

   public boolean newsendMail(JSONObject param, MailModel model) throws Exception {
      if("haier".equals(Convert.toReadStr(this.company))) {
         SendMailHaier tools = new SendMailHaier();
         return tools.sendMail(param, model);
      } else {
         this.logger.error("没有配置发邮件公司信息！[siit.mail.company]");
         return true;
      }
   }

   private MailModel loadTemp(String path) throws Exception {
      MailModel result = MailTemplate.getTemplate(path);
      if(result == null) {
         ClassPathResource classPathResource = new ClassPathResource(path);
         if(classPathResource.exists()) {
            InputStream inputStream = classPathResource.getInputStream();
            BufferedReader reader = new BufferedReader(new InputStreamReader(inputStream));
            StringBuilder builder = new StringBuilder();
            String line = null;

            try {
               while((line = reader.readLine()) != null) {
                  builder.append(line);
                  builder.append("\n");
               }
            } catch (IOException var19) {
               var19.printStackTrace();
            } finally {
               try {
                  inputStream.close();
               } catch (IOException var18) {
                  var18.printStackTrace();
               }

            }

            String xslresult = builder.toString();
            if(!"".equals(xslresult)) {
               MailModel model = new MailModel();
               Document doc = DocumentHelper.parseText(xslresult);
               Element root = doc.getRootElement();
               Element head = root.element("HEAD");
               model.setTitle(Convert.toReadStr(head.elementText("mailtitle")));
               model.setCc(Convert.toReadStr(head.elementText("mailcc")));
               model.setConetnttemp(xslresult);
               MailTemplate.addTemplate(path, model);
               result = model;
            }
         } else {
            this.logger.error("没有配置邮件模版，返回！[" + path + "]");
         }
      }

      return result;
   }

   public static void main(String[] a) {
      SiitMailTools m = new SiitMailTools();

      try {
         m.sendMail((JSONObject)null, "signfor");
      } catch (Exception var3) {
         var3.printStackTrace();
      }

   }
}
